/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */

// ===========================================================================
//
// File name    : apbmdebug.h
// Author       : Vladimir Revzin
// Version      :
// Description  : Debug definitions for BM AP
// ===========================================================================

#ifndef _APBM_DEBUG_H_
#define _APBM_DEBUG_H_

typedef struct _COUNTERS_DESCRIPT       /* Point of View : CPE*/
{
/* 1- Producer information : related to InputQ of BM APU */
  unsigned long  numPutTrials;   /* default value = 0x0000 */
  unsigned long  numPutSucceed;  /* default value = 0x0000 */
  unsigned long  putByAPRequest; /* default value = 0x0000 */
  unsigned long  putReserve2;    /* default value = 0x0000 */

/* 2- Consumer information : related to OutputQ of BM APU */
  unsigned long  numGetTrials;   /* default value = 0x0000 */
  unsigned long  numGetSucceed;  /* default value = 0x0000 */
  unsigned long  getByAPRequest; /* default value = 0x0000 */
  unsigned long  getReserve2;    /* default value = 0x0000 */

/* 3- Consumer information : related to requests from BM APU */
  unsigned long  numno_free_space_atramq;   	/* default value = 0x0000 */
  unsigned long  numlot_pointers_atramq;    	/* default value = 0x0000 */
  unsigned long  numshortage_pointers_atramq;   /* default value = 0x0000 */
  unsigned long  numshortage_pointers_atbm;     /* default value = 0x0000 */

/* 4 Auxiliary information */
  // This is number frames which was allocated and dropped due "wrong" location inside SDRAM
  unsigned long  num_alloc_and_dropped_framed; 	/* default value = 0x0000 */
  unsigned long  auxReserve[3];    /* default value = 0x0000 */

  /* 5 uart2 related information */
  unsigned long  numGet2Trials;   /* default value = 0x0000 */
  unsigned long  numGet2Succeed;  /* default value = 0x0000 */
  unsigned long  numPut3Trials;   /* default value = 0x0000 */
  unsigned long  numPut3Succeed;  /* default value = 0x0000 */

} BM_COUNTERS_DESCRIPT,  *PBM_COUNTERS_DESCRIPT;


#endif /* _APBM_DEBUG_H_ */
