/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */

// ===========================================================================
//
// File name    : $RCSfile: apinpq.h,v $
// Description  : The I/O layout and bit definitions for the AP input queue
//                hardware.
// ===========================================================================

#ifndef _APINPQ_H_
#define _APINPQ_H_

#define AP_INPQ_CTRL_OFF        0x0     // Input queue control
#define AP_INPQ_DEFER_BIT       0       // 1 = Defer AHB cycles on queue full
                                        // 0 = accept and discard data if full

#define AP_INPQ_STATUS_OFF      0x1     // Input queue status
#define AP_INPQ_NOT_EMPTY_BIT   0       // Queue not empty. This bit is also
                                        // connected to an AP input flag
#define AP_INPQ_LOST_BIT        1       // Queue entries lost. Cleared by
                                        // writing '1' to the bit
#define AP_INPQ_FULL_BIT        2       // Input queue is full
#define AP_INPQ_LEVEL_MSK       0x0070  // Mask for current #32 items in queue

#define AP_INPQ_MSW_OFF         0x2     // Queue entry MSW
#define AP_INPQ_LSW_OFF         0x3     // Queue entry LSW. Queue will
                                        // be popped when this
                                        // entry is read

#endif /* _APINPQ_H_ */
