/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */

// ===========================================================================
//
// File name    : apmacros.h
// Description  : This file defines the macros to use in AP programming
//
// ===========================================================================

#ifndef _APMACROS_H_
#define _APMACROS_H_



/* Useful macros to load 16 and 32 bits values into memory of AP */
#define _LOAD_VAR_32( item, value ) \
        li    r0, HIGHW value       \
        sw    r0, item              \
        li    r0, LOWW value        \
        sw    r0, item + 2

#define _LOAD_VAR_16( item, value ) \
    li    r0, item                  \
    li    r1, value                 \
    sw    r1, r0

#define _INIT_ARRAY_ELEM_16( array, elemNum, value ) \
    li    r0, array                 \
    li    r1, elemNum               \
    li    r2, value                 \
    rl    r1                        \
    add   r1, r0                    \
    sw    r2, r1

// Macros below represent CLASS_DMA macros whcih will be "open" in compilation time
#define cat(x, y)		x ## y
#define xcat(x, y)		cat(x, y)

#define CLASS_DMA_ACCESS	li   ra, xcat( ahbDmaAccess, CLASS_DMA ) \
				call ra

#define CLASS_DMA_ACCESS_IF_ID	li   ra, xcat( ahbDmaAccess, CLASS_DMA ) \
				call if id ra
#endif /* _APMACROS_H_ */
