/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */

// ===========================================================================
//
// File name    : $RCSfile: apoutpq.h,v $
// Description  : The I/O layout and bit definitions for the AP output queue
//                hardware.
// ===========================================================================

#ifndef _APOUTPQ_H_
#define _APOUTPQ_H_

#define AP_OUTPQ_CTRL_OFF       0x0     // Output queue control
#define AP_OUTPQ_DEFER_BIT      0       // 1 = Defer AHB cycles on queue empty
                                        // 0 = Return 0 on queue empty

#define AP_OUTPQ_STATUS_OFF     0x1     // Output queue status
#define AP_OUTPQ_NOT_FULL_BIT   0       // Queue not full. This bit is also
                                        // connected to an AP input flag
#define AP_OUTPQ_LOST_BIT       1       // Queue read while empty. Cleared by
                                        // writing '1' to the bit
#define AP_OUTPQ_NOT_EMPTY_BIT  2       // Queue not empty

/* The next two registers are "halves" of the 32bit word on the queue.
 *
 * The MSW should be set up first, then the LSW should be written. This will
 * push the 32bit number formed from MSW and LSW onto the output queue
 */
#define AP_OUTPQ_MSW_OFF        0x2     // Queue entry MSW
#define AP_OUTPQ_LSW_OFF        0x3     // Queue entry LSW. Queue will
                                        // be pushed when this
                                        // entry is written

#endif /* _APOUTPQ_H_ */
