/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */

#ifndef _APSTATS_H_
#define _APSTATS_H_

#include <sysconf.h>
	
#include <ethdriver/std_ap/apethconfig.h>
#include <netpro/apbm.h>
#ifdef IPSEC
#include <netpro/secapsa.h>
#endif

#if defined(ATM_AP) && (ATM_AP)
#include <atm/atm.h>
#endif

#ifdef CONFIG_FUSIV_KERNEL_PERI_AP
#include "../../peri_ap/appericonfig.h"
#endif

#if defined(ACL_AP) && (ACL_AP)
#include <acl_ap/apaclconfig.h>
#endif

#if defined(IS_VX185) && (IS_VX185)
#include "../../classifier/apclconfig.h"
#endif

#ifdef VX185_BONDING
#include <netpro/apvdslptmbondingstats.h>
#endif /* VX185_BONDING */
typedef struct commonStatsInfo_s
{
    union
    {
        ethStats_t      ethStats;
  #ifdef VX185_BONDING
		ethStats_bonding_t ethStats_bonding;
  #endif /* VX185_BONDING */

        apBMStatsInfo_s bmStats;
#ifdef IPSEC
        apSecStats_t    secStats;
#endif

#if defined(ATM_AP) && (ATM_AP)

        atmStatistics_t atmStats;
#endif
#ifdef CONFIG_FUSIV_KERNEL_PERI_AP
        apPERIStatsInfo_s periStats;
#endif
#if defined(ACL_AP) && (ACL_AP)
        apACLStats_t 	aclStats;
#endif
#if defined(IS_VX185) && (IS_VX185)
	CLStats_t      CLStats[NUM_CBPORTS_PER_CLAP]; //2 -> because clap processes 2 cbports
#endif
    } cStatsInfo_t;
} commonStatsInfo_t;

#if 1	//CACHE::
// Important for CACHE WRITE BACK MODE
// Below definitions are created to have all entries on different cache lines
// In this case a situation when Host and AP are updating elements of different structures
// on the SAME cache line and Host is doing cache flush will be resolved properly
// WITHOUT AP portion data loss.

#ifdef AP_ASSEMBLER
    #define RT_PADDING_TILL_CLINE       (CACHE_LINE_SIZE - (sizeof typedef commonStatsInfo_t & (CACHE_LINE_SIZE - 1)))
#else
    #define RT_PADDING_TILL_CLINE       (CACHE_LINE_SIZE - (sizeof(commonStatsInfo_t) & (CACHE_LINE_SIZE - 1)))
#endif

typedef struct commonStatsInfo_s_chaligned
{
        commonStatsInfo_t   commonStatsInfoMain;
        unsigned char   reserved[RT_PADDING_TILL_CLINE];
} commonStatsInfo_t_chaligned __attribute__((aligned(CACHE_LINE_SIZE)));
#undef RT_PADDING_TILL_CLINE

#ifdef AP_ASSEMBLER
assert (sizeof typedef commonStatsInfo_t_chaligned & (CACHE_LINE_SIZE - 1)), 0
#else
 //will do it later
//assert (0 == (sizeof(commonStatsInfo_t_chaligned) & (CACHE_LINE_SIZE - 1)));
#endif
#endif		//CACHE::

#endif /* _APSTATS_H_ */
