/* =============================================================================
 *
 * Copyright (C) 2003 Analog Devices Inc. All rights reserved
 *
 * The information and source code contained herein is the exclusive property
 * of Analog Devices and may not be disclosed, examined or reproduced in whole
 * or in part without the explicit written authorization from Analog Devices.
 *
 * ===========================================================================*/

//======================================================================
// File Name	:	$RCSfile: apvdslptmbondingstats.h,v $
// Description	:	Configuration data structure and information for the
//                      VDSL AP in packet Transfer Mode.
//======================================================================

#ifndef _APPTMSTATS_H_
#define _APPTMSTATS_H_

#include <netpro/apconf.h>
#include <sysconf.h>
#include <netpro/apEfmBondingconfig.h>

/* Define the statistics held by the VDSL AP */

typedef struct
{
    unsigned long       rxPktCnt;       // Correctly received packets including CRC errors
    unsigned long       txPktCnt;       // Successfully sent packets
    unsigned long       crcErrCnt;      // CRC error packets.
    unsigned long       inQ1DeqCnt;     // packets dequeued from inputQ1
    unsigned long       inQ2DeqCnt;     // packets dequeued from inputQ2
    unsigned long       inQ1FullDropCnt;// Dropped packet due to inputQ1 is full.
    unsigned long       lmEnqCnt;       // Successfully enqueued to LM.
    unsigned long       lmDeqCnt;       // Successfully dequeued from LM
    unsigned long       lmQFullDropCnt; // Drop counter due to LM Q full.
    //unsigned long long        rxBytes;        // number of bytes received.
    //unsigned long long        txBytes;        // number of bytes sent.        
    apWfqStatInfo_t     wfqStat;        // WFQ Statistics
	unsigned long	txPktCnt_ch0;
	unsigned long 	txPktCnt_ch1;
	unsigned long   rxPktCnt_ch0;
	unsigned long   rxPktCnt_ch1;
	efmReassemStats_t	bondingReasmStats;
} ethStats_bonding_t;

#endif /* _APPTMSTATS_H_ */
