/****************************************************************************************
 *                                                                                      *
 * Copyright (C) 2007 Ikanos Communications Inc. All rights reserved                    *
 *                                                                                      *
 * The  information  and  source  code contained  herein  is the  exclusive  property   *
 * of Ikanos Communications and may not be disclosed, examined or reproduced in whole   *
 * or in part without  the explicit written authorization from Ikanos Communications.   *
 *                                                                                      *
 ****************************************************************************************/

/****************************************************************************************
 *                                                                                      *
 * File name    : l2tp.h                                                           	*
 * Author       : Ikanos Communications  [ bvalaboj@ikanos.com ]                        *
 * Version      :                                                                       *
 * Date         : 07th Mar 2012                                                         *
 * Description  : This file contains L2TP tunnel related structures.     		*
 *											*
 *                                                                                      *
 ****************************************************************************************/

/*_____________________________________Header Gaurd_____________________________________*/

#ifndef _L2TP_H_
#define _L2TP_H_

typedef struct udpTunnelAddr_s
{
    unsigned short srcPort;
    unsigned short dstPort;
}udpTunnelAddr_t;

typedef struct pppTunnelAddr_s
{
    unsigned short AFC;        /* Address and control fields - 0xff03 */
    unsigned short protocol;   /* PPP Protocol - 0x0021 for IP */
}pppTunnelAddr_t;

typedef struct l2tpTunnelId_s
{
    unsigned short tunnId;
    unsigned short sessId;
}l2tpTunnelId_t;

typedef struct l2tpTunnelStats_s
{
    unsigned long       decapPktCnt;  /* Rx Success   */
    unsigned long       decapErrCnt;  /* Rx Failure   */
    unsigned long       encapPktCnt;  /* Tx Success   */
    unsigned long       encapErrCnt;  /* Tx Failure   */
    unsigned long       hostPktCnt;   /* Pkts to Host */
}l2tpTunnelStats_t;

typedef struct l2tpTunnelParams_s
{
    l2tpTunnelId_t srcTunId; /* Source L2TP Tunnel Details */
    l2tpTunnelId_t dstTunId; /* Destination L2TP Tunnel Details */
    unsigned short mtu;
    unsigned short mru;
#define L2TP_FP_HDRFLAG_T        0x8000
#define L2TP_FP_HDRFLAG_L        0x4000
#define L2TP_FP_HDRFLAG_S        0x0800
#define L2TP_FP_HDRFLAG_O        0x0200
#define L2TP_FP_HDRFLAG_P        0x0100
#define L2TP_FP_HDR_VER_FLAG     0x000f

#define L2TP_FLAG_LEN_BIT         0x1
#define L2TP_FLAG_SEQ_BIT         0x2
#define L2TP_FLAG_MODE_LNS_BIT    0x3    
#define L2TP_FLAG_MODE_LAC_BIT    0x0    
#define L2TP_FLAG_VER_BIT_MASK    0xC0 
#define L2TP_FLAG_VER_2           0x80
#define L2TP_FLAG_VER_3           0xC0
    unsigned char flags; 
    unsigned short nr;  /* Receive Sequence */
    unsigned short ns;  /* Send Sequence */
}l2tpTunnelParams_t;

#endif
