/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */


//============================================================================
// File Name    :       secipc.asm
// Description  :
// CVS ID       :
//============================================================================

/* This file contains the ethernet port receive code. This code performs the
 * following functions
 */


#define AP_IPC_Q_TO_HOST        4
#include <netpro/apipccfg.h>
#include <netpro/apsyscfg.h>
#include <netpro/apprehdr.h>   // egress port definition

#define   SAP_TO_HOST_Q1  0
#define   SAP_TO_HOST_Q2  1
#define   SAP_TO_HOST_Q3  2
#define   SAP_TO_HOST_Q4  3

#define   AP_SEC_Q_TO_HOST  2
//#define   SEC_HOST_MAX_Q_SZ 10

#define   SEC_AP_IN_Q     0x19100510
#define   SEC_AP_E_PKT    0x1000

#define   SEC_AP_EGRESS_HOST
#define   SEC_AP_EGRESS_ERR


typedef struct secconfig_s
{
    unsigned long   *pPortAddr;      // of my own I/P address.

    apSysConfig_t    sys;            // System configuration
    apIpcConfig_t    ipc;            // IPC configuration

    apEgressPort_t   errorEgress;    //Queue for Error pkts
    apEgressPort_t   protoEgress1;   //Queue1 for AH/ESP proto pkts
    apEgressPort_t   protoEgress2;   //Queue2 for AH/ESP proto pkts

} secApConfig_t;

#if 1   //CACHE::
// Important for CACHE WRITE BACK MODE
// Below definitions are created to have all entries on different cache lines
// In this case a situation when Host and AP are updating elements of different structures
// on the SAME cache line and Host is doing cache flush will be resolved properly
// WITHOUT AP portion data loss.

#ifdef AP_ASSEMBLER
    #define APSEC_PADDING_TILL_CLINE       (CACHE_LINE_SIZE - (sizeof typedef secApConfig_t & (CACHE_LINE_SIZE - 1)))
#else
    #define APSEC_PADDING_TILL_CLINE       (CACHE_LINE_SIZE - (sizeof(secApConfig_t) & (CACHE_LINE_SIZE - 1)))
#endif

typedef struct
{
        secApConfig_t     secAPConfigMain;
        unsigned char   reserved[APSEC_PADDING_TILL_CLINE];
} secApConfig_t_chaligned __attribute__((aligned(CACHE_LINE_SIZE)));

#ifdef AP_ASSEMBLER
assert (sizeof typedef secApConfig_t_chaligned & (CACHE_LINE_SIZE - 1)), 0
#else
//assert (0 == (sizeof(secApConfig_t_chaligned) & (CACHE_LINE_SIZE - 1)));
#endif
#endif          //CACHE::
