/****************************************************************************************
 *                                                                                      *
 * Copyright (C) 2007 Ikanos Communications Inc. All rights reserved                    *
 *                                                                                      *
 * The  information  and  source  code contained  herein  is the  exclusive  property   *
 * of Ikanos Communications and may not be disclosed, examined or reproduced in whole   *
 * or in part without  the explicit written authorization from Ikanos Communications.   *
 *                                                                                      *
 ****************************************************************************************/

/*_____________________________________Header Gaurd_____________________________________*/

#ifndef _APTXINFO_H_
#define _APTXINFO_H_

/*_____________________________________INCLUDES_________________________________________*/
#if 0
typedef struct apTxInfo_s
{
    void        *pCluster;                              /* 32 bits */
    unsigned char       startOffset;                    /* 8 bits */
#define     TXINFO_QUEUE_NUM_MASK      0x07
#define     TXINFO_READ_PRE_HDR        3
#define     TXINFO_ENQUE_AT_HEAD       4
//NOTE: Following 5,6 & 7 bits, are only used for mesh loopback. 
//For other applications, these bits can be reused.
#define	    TXINFO_CBPORT_BIT0	       5	
#define     TXINFO_CBPORT_BIT1         6
#define	    TXINFO_CBPORT_BIT2         7
//NOTE: Following bit 6 is used for packets coming to SEC AP
// to differentiate between ACL and IPSec functionalities
// For IPSec packet processing this bit should be set as 1
#define     TXINFO_IPSEC_BIT           6

// This bit is used to indicate that it is a tcp ack packet
#define	    TXINFO_TCP_ACK_PKT_BIT      5
    unsigned char	    splPktInfo;                  /* 8 bits - Least significant 3 bits indicate the queue number*/
#define     TXINFO_PKT_LENGTH_MASK      0x3fff   
#if defined(AP_FRAGMENTATION) && (AP_FRAGMENTATION)
#define     TX_FRAGMENTATION_BIT        15
#endif
        unsigned short  length;       			/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
} apTxInfo_t;
#endif

typedef struct apTxInfo_s
{
    void        *pCluster;                              /* 32 bits */

/* NOTE: These fields need to be carefully chosen. Should not conflict with each other */
/* Below fields are used as value */
#define     TXINFO_START_OFFSET_MASK        0x1ff       /* bits 9-0 bits foe start offset */
#define     TXINFO_START_OFFSET_INV_MASK    0xfe00      /* bit inverted */

/* These masks are used for QUEUE Num and CBPort Num after rotating to bits 2-0 */
#define     TXINFO_QUEUE_NUM_SIZE_MASK  0x7         /* bits 15-13 for Queue number mask, depends on start offset length */
#define     TXINFO_QUEUE_NUM_MASK       0xe000      /* bits 15-13 for Queue number mask, depends on start offset length */

#define     TXINFO_CBPORT_SIZE_MASK     0x7         /* bits 15-13 for indicating the original CBPort value - Only used by MESH loopback pkts. */
#define     TXINFO_CBPORT_MASK          0xe000      /* bits 15-13 for indicating the original CBPort value - Only used by MESH loopback pkts. */

/* Other Individual FLAGS for different purpose */
#define     TXINFO_READ_PRE_HDR         9
#define     TXINFO_ENQUE_AT_HEAD        10

/* NOTE: Following bit 14 is used for packets coming to SEC AP to differentiate between ACL and IPSec functionalities */
#define     TXINFO_IPSEC_BIT            11       /* For IPSec packet processing this bit should be set as 1 */
#define	    TXINFO_TCP_ACK_PKT_BIT      12       /* This bit is used to indicate that it is a tcp ack packet */

/* ***** Need to remove these in MESH - Use above new definition ***** */ 
/* NOTE: bits 12 -14 are only used for mesh loopback */
/* these are re-used by other flows as defined above */
#define	    TXINFO_CBPORT_BIT0	        13
#define     TXINFO_CBPORT_BIT1          14
#define	    TXINFO_CBPORT_BIT2          15
#ifdef VX185_BONDING
// This bit is used to indicate VDSL line number thru which the packet should be 
#define     TXINFO_VDSL_PHY_BIT        15
 #endif

    unsigned short	    splPktInfo;             /* 16 bits for indicating packet info as defined above */
    
    
#define     TXINFO_PKT_LENGTH_MASK     0x3fff   
#if defined(AP_FRAGMENTATION) && (AP_FRAGMENTATION)
#define     TX_FRAGMENTATION_BIT       15
#endif
        unsigned short  length;       			/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
} apTxInfo_t;

#if 0
typedef struct apAtmTxInfo_s
{
    void        *pCluster;                              /* 32 bits */
    unsigned char       startOffset;                    /* 8 bits */
    unsigned char	    splPktInfo;                 /* 8 bits - Least significant 3 bits indicate the queue number*/
        unsigned short  length_with_overhead;      	/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
        unsigned short  length;       			/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
	unsigned short	dummy;
} apAtmTxInfo_t;

typedef struct apEthTxInfo_s
{
    void        *pCluster;                              /* 32 bits */
    unsigned char       startOffset;                    /* 8 bits */
    unsigned char	    splPktInfo;                 /* 8 bits - Least significant 3 bits indicate the queue number*/
        unsigned short  length_with_overhead;      	/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
        unsigned short  length;       			/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
	unsigned short	dummy;
} apEthTxInfo_t;
#endif


typedef struct apAtmTxInfo_s
{
    void            *pCluster;                              /* 32 bits */
//    unsigned char   startOffset;                    /* 8 bits */
    unsigned short	splPktInfo;                 /* 8 bits - Least significant 3 bits indicate the queue number*/
    unsigned short  length_with_overhead;      	/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
    unsigned short  length;       			/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
	unsigned short	dummy;
} apAtmTxInfo_t;

typedef struct apEthTxInfo_s
{
    void            *pCluster;                              /* 32 bits */
//    unsigned char   startOffset;                    /* 8 bits */
    unsigned short	splPktInfo;                 /* 8 bits - Least significant 3 bits indicate the queue number*/
    unsigned short  length_with_overhead;      	/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
    unsigned short  length;       			/* Length is 14 bits[13:0],[15:14] - SplPktInfo  */
	unsigned short	dummy;
} apEthTxInfo_t;

/*
 * Following structure is used in apTransmit(hostapipc.c) fuctions. To ease the coding.
 */
typedef union apTxInfoUnion_s
{
	apTxInfo_t	apTxInfo;
	UINT32		unionApTxInfo[2];
}apTxInfoUnion_t;
                                        
/*_____________________________________Header Gaurd_____________________________________*/
#endif  //_APTXINFO_H_ end of header guard.

