/****************************************************************************************
 *                                                                                      *
 * Copyright (C) 2007 Ikanos Communications Inc. All rights reserved                    *
 *                                                                                      *
 * The  information  and  source  code contained  herein  is the  exclusive  property   *
 * of Ikanos Communications and may not be disclosed, examined or reproduced in whole   *
 * or in part without  the explicit written authorization from Ikanos Communications.   *
 *                                                                                      *
 ****************************************************************************************/

/****************************************************************************************
 *                                                                                      *
 * File name    : classlib.h                                                            *
 * Author       : Ikanos  [ jpattar@ikanos.com ]                              		*
 * Version      :                                                                       *
 * Date         : 08th Oct 2009                                                         *
 * Description  : This file contains the structure of parser output                     *
 *                to store packet information. It also contain information to carry     *
 *                to transmiting interface.                                             *
 *                                                                                      *
 ****************************************************************************************/

/*_____________________________________Header Gaurd_____________________________________*/
#ifndef _CLASSLIB_VX185_H_
#define _CLASSLIB_VX185_H_


/*_______________________________________INCLUDES_______________________________________*/
//#include "commomconfig.h"
//#include "parsertag.h"

/*________________________________________MACROS________________________________________*/
#define PARSERTAG_OFFSET        56+128+8 //PARSER_HOLE1 + PACKET_HEADER_SIZE + PARSER_HOLE2
#define	PARSERHOLE2_OFFSET	56+128   //PARSER_HOLE1 + PACKET_HEADER_SIZE

/*______________________________________STRUCTURES______________________________________*/

#define	CLASSBUF_FLAG_READY  		0 

#define	CLASSBUF_FLAG_PROCESSING_BIT 	0	//Preclassify task
#define	CLASSBUF_FLAG_LOOPBACK_BIT	4
#define	CLASSBUF_FLAG_CBPORT_BIT0	TXINFO_CBPORT_BIT0 //Stores CBPORT address for loopback
#define CLASSBUF_FLAG_CBPORT_BIT1    	TXINFO_CBPORT_BIT1 //Stores CBPORT address for loopback
#define	CLASSBUF_FLAG_CBPORT_BIT2	TXINFO_CBPORT_BIT2 //Stores CBPORT address for loopback


//Make sure the following structure should be multiple of 4; it should parser hole2 length
typedef struct
{
    	unsigned short	packetLength;
	unsigned char	flag;		// Current state from apClassState_e
	unsigned char 	specInfoElement;// Used by WLAN
	unsigned long	clusterAddr;	// Cluster address passed using HOLE 2
} classBufInfo_t;

typedef struct
{
	//unsigned char	packetHdr[PARSER_HOLE1 + PACKET_HEADER_SIZE];
	unsigned char	packetHdr[40 + 128];
	classBufInfo_t	classInfo;
	parserTag_t	parserTag;
}classBuf_t;


/*_____________________________________HEADER GAURD_____________________________________*/
#endif /* _CLASSLIB_H_ */
