/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */


#ifndef  SYSCONF_E_E_R_H
#define  SYSCONF_E_E_R_H

#include <linux/autoconf.h>
/* !Note! Be sure to use only the conditional directive #if
 * for feature that uses YES/NO macros.
 * Do not use #ifdef for feature that uses YES/NO macro
 * because the feature will be included even though the user
 * specifies NO.
 */
#define AP_BUFFER_SIZE  2304    // Actual length of a buffer.
#define YES		1
#define NO		0

#define IS_NETPRO         YES      /* It's a Netpro chip */
#define CHIP_NAME         ad6843   /* It's a target Chip Name */

#define USE_RTOS				NO	// kambiz
#define BRIDGE_THRU_AP  NO      /* Enable AP support for Bridge datapath */
#define BUF_CPY_THRU_DMA  YES      /* Enable DMA support for Buffer COPY */

#define AP_IPQOS        YES

/* These three macros have been used to check whether ADSL or VDSL driver loaded.
   These should be compared with global variable guc_avdsl_module. */
#define AVDSL_NO_MODULE			0
#define AVDSL_ADSL_MODULE		1
#define AVDSL_VDSL_MODULE		2
#define NUM_NETPRO_ATM_VCC_SUPPORTED    17 /* no. of supported VCCs is only '16'. 
					      The value has been kept as 17 to address the memory 
					      access issue with 16th PVC. This change will ensure that
					      sufficient LMEM is allocated for the 16th PVC config structures  */

#if defined(CONFIG_ATM) && CONFIG_ATM
#define IS_EAGLEPLUS			YES	// kambiz
#define MUXED_BUS_EAGLEPLUS		YES	// kambiz
#define ADSL            YES // kambiz
#define ATM             YES
#define SNDCP           YES
#define ATM_AP          YES     /* Enable ATM AP on the AD6843 */

/* Right now these two MACROS are used in a mutually exclusive manner - If one is YES the other is NO */
#define ATM_UPSTREAM_THRU_HOST NO /* Enable upstream thru host **/
#ifdef CONFIG_FUSIV_VX185
#define ATM_UPSTREAM_THRU_HOST_NETFILTER_BYPASS NO /* Disabled as complete fastpath is established in Vx185 **/
#define ATM_UPSTREAM_FOR_AP_FRAGMENTATION       YES /* Enabled as AP Fragmentation for ATM egress happens in Host **/
#else
#define ATM_UPSTREAM_THRU_HOST_NETFILTER_BYPASS YES /* Enable upstream thru host but bypass netfilter **/
#endif

#define PCR_LIMIT_IN_UBR	1
/* UBR not configured with any PCR Limit, and hence operates on Round Robin mode*/
#define UBR_RR_PCR          1
#define MINIMUM_CELL_RATE_UBR_PLUS  	1

/*============================================================================
 * ADSL DEPENDENT ITEMS
 *===========================================================================*/
#define ITU_VENDOR_ID_STR  "ANDV"  /* Has to be a 4 symbol string( CMVs INFO 21/22) */

/* Adsl default mode configuration */
#define DEFAULT_ADSL_MODE   YES
  #if  DEFAULT_ADSL_MODE
    #define ADSL_MODE   1        /* T1413 - 1, GDMT -2,GLITE-3,MULTI-4 */
  #endif

#endif /* CONFIG_ATM */

//#if CONFIG_FUSIV_KERNEL_PERI_AP || CONFIG_FUSIV_KERNEL_PERI_AP_MODULE
/* Following Macro is to enable support in host code for ETH-WLAN Hdr
*  conversion at AP level.
*  It's mandatory that WLAN_ETH_8023 macro in inc/netpro/apconf.h must be
*  defined to have this support at AP level */
//#define ETH_WLAN_HDR_CONVERT 1
//#endif


/* =====================================================================
 * Needs to be enabled only in case of AP code developement
 * =====================================================================
 */
#define DUMP_INFO_FEATURE       0


#ifdef CONFIG_FUSIV_VX160
#define VENDOR_NAME     VOX160
#define IS_AT200        YES
#define IS_VX160        YES
#define WRITE_BACK_CACHE      0    /* Always 0 for vx160 */
#define WRITE_THROUGH_CACHE   1    /* Always 1 for vx160 */
#define CACHE_LINE_SIZE       32   /* cache line size in bytes */
#define NUM_EMAC_PORTS  2       /* No. of on-board EMAC interfaces  */
#else
#define IS_VX160        NO
#endif

#ifdef CONFIG_FUSIV_VX180
#ifdef CONFIG_FUSIV_VX180_WRITE_BACK
#define WRITE_BACK_CACHE    1       /* 1 - enable, 0 - disable */
#else
#define WRITE_THROUGH_CACHE   1
#endif
#define CACHE_LINE_SIZE     32      /* cache line size in bytes */
#define VENDOR_NAME     VOX180          //VOX200_H323
#define NUM_EMAC_PORTS  2       /* No. of on-board EMAC interfaces  */
#define IS_VX180        YES

#if defined(CONFIG_FUSIV_KERNEL_BME_DRIVER_VX180) || defined(CONFIG_FUSIV_KERNEL_BME_DRIVER_VX180_MODULE)
#define VDSL_AP         YES
#endif
#else
#define IS_VX180        NO
#endif

#ifdef CONFIG_FUSIV_VX185
#ifdef CONFIG_FUSIV_VX180_WRITE_BACK
#define WRITE_BACK_CACHE    1       /* 1 - enable, 0 - disable */
#else
#define WRITE_THROUGH_CACHE   1
#endif
#define CACHE_LINE_SIZE     32      /* cache line size in bytes */
#define VENDOR_NAME     VOX185          //VOX200_H323
#ifdef CONFIG_FUSIV_VX175
#define NUM_EMAC_PORTS  3       /* No. of on-board EMAC interfaces  */
#define IS_VX175        YES
#else
#define NUM_EMAC_PORTS  2       /* No. of on-board EMAC interfaces  */
#define IS_VX175        NO
#endif
#define IS_VX185        YES
//TCK:: Enabling ACL:  #undef	ACL_AP

// For now defining as Vx180 #if defined(CONFIG_FUSIV_KERNEL_BME_DRIVER_VX185) || defined(CONFIG_FUSIV_KERNEL_BME_DRIVER_VX185_MODULE) 
#if defined(CONFIG_FUSIV_KERNEL_BME_DRIVER_VX180) || defined(CONFIG_FUSIV_KERNEL_BME_DRIVER_VX180_MODULE) 
#define VDSL_AP         YES
#endif

//TCK:************************ ACL CONFIGURATIONS FOR VX185 ****************************/

#if defined(CONFIG_FUSIV_KERNEL_ACL) || defined(CONFIG_FUSIV_KERNEL_ACL_MODULE)

#define ACL_AP          1

#ifdef CONFIG_FUSIV_KERNEL_ACL_EMAC3
#define ACL_USING_Vx185_EMAC3  1
#elif CONFIG_FUSIV_KERNEL_ACL_SPA
#define ACL_USING_Vx185_SPA    1
#endif

#endif

//TCK:******************** END OF ACL CONFIGURATIONS FOR VX185 **************************/

#endif

#if defined(IS_VX160) && IS_VX160  /* For now we only support this officially for KT on VX-160, 2*Eth, Free ATM AP */

#if defined(CONFIG_FUSIV_KERNEL_ACL) || defined(CONFIG_FUSIV_KERNEL_ACL_MODULE)
#define ACL_AP					1	/* ACL-AP, this hijacks a particular AP to run ACL firewall policies
 									 *  this AP is defined xxxx (for now its the ATM-AP)
									 */
#endif


#if defined(ACL_AP) && ACL_AP   /* Make sure we disable the ATM_AP loading/functionality if we're running ACL-AP */
//#error "****************"
//#error "INSIDE SYSCONF.H"
//#error "****************"
	#undef CONFIG_ATM
	#if ATM_AP
		#undef  ATM_AP
		#define ATM_AP 			0
	#endif
	#define ACL_USING_ATM	1	/* For the apinit.c otherwise it disables the ATM-AP since we're not using ATM! */
	#ifndef ACL_USING_ATM
		#error "You need to change the interrupt in acl_ap_driver.c 'dev->irq = EMAC3_INT' to correct interrupt!"
		#error "You will likely have to change acl_ap_driver.c acl_ap_probe() as it inits the ATM AP clocks"
	#endif
#endif
#endif

#if defined(IS_VX180) && IS_VX180
#if defined(CONFIG_FUSIV_KERNEL_ACL) || defined(CONFIG_FUSIV_KERNEL_ACL_MODULE)
#define ACL_AP          1
/* ACL-AP, this hijacks a particular AP to run ACL firewall policies*/
#endif

#if defined(ACL_AP) && ACL_AP

#ifdef CONFIG_FUSIV_KERNEL_ACL_EMAC3
#define ACL_USING_Vx180_EMAC3  1
#elif CONFIG_FUSIV_KERNEL_ACL_SPA
#define ACL_USING_Vx180_SPA    1
#endif

#endif // ACL_AP

#endif // IS_VX180

/* These two symbolic constants have been used to check whether SEP AP is downloaded with IPSec code
   These should be compared with global variable guc_secap_module. */
#define SECAP_NO_MODULE			0
#define SECAP_MODULE			1

#endif /* SYSCONFE_E_R */

